package gui;

sub new 
{ 
	my $class=shift;
	my $self={};	
	my $fm=shift;

	$self->{lcwd}=$fm->getlcwd;
	$self->{rcwd}="";

	my $t=$self->{top}=new Tk::MainWindow(-title=>"elFtp");
	#local $dir_lb=$top->Listbox(-width=>80);
	#local $file_lb=$top->Listbox(-width=>80);
	$self->{remote}=$t->Listbox();

	$self->{remote_scroll}=$t->Scrollbar();
	$self->{remote}->configure (-yscrollcommand=>['set', $self->{remote_scroll}]);
	$self->{remote_scroll}->configure(-command=>['yview', $self->{remote}]);
	
	$self->{"local"}=$t->Listbox();
	$self->{local_scroll}=$t->Scrollbar();
	$self->{"local"}->configure (-yscrollcommand=>['set', $self->{local_scroll}]);
	$self->{local_scroll}->configure(-command=>['yview', $self->{"local"}]);
	
	my $bf=$self->{button_frame}=$t->Frame(-relief=>"groove",-borderwidth=>3);	# buttons for general buttons
	my $bfl=$self->{l_button_frame}=$t->Frame();	# buttons for local operations
	my $bfr=$self->{r_button_frame}=$t->Frame();	# buttons for remote operations
	
	# the connect_button takes the connect button gui args, then connect args, then args forwarded to 
	# the dir routine.
	$self->{connect_button}=$bf->Button 
	( 
		-text=>"connect" , 
		-relief=>"groove",
		-command=>[ 
			sub { $fm->connect(@_) }, 
			$self, {} ,  [ \$self->{remote} ]
			]
	);

	$self->{bmarks_button}=$bf->Button 
	( 
		-text=>"edit bookmarks" , 
		-relief=>"groove",
		-command=>[ 
			sub { $fm->bookmarks(@_) },
			$self
			]
	);


	$self->{quit_button}=$bf->Button 
	(
		-text=>"quit", 
		-relief=>"groove",
		-command=>[ 
			sub { $self->DESTROY; $fm->quit; } 
			]  
	);

	$self->{get_button}=$bfr->Button 
	(
		-text=>"get", 
		-relief=>"groove",
		-command=>[ 
		sub { $fm->cwd(@_)	},
		$self, [ \$self->{remote} ]
		] 
	);
	$self->{put_button}=$bfl->Button 
	(
		-text=>"put", 
		-relief=>"groove",
		-command=>[ 
		sub { $fm->lcwd(@_) },
		$self,[ \$self->{"local"} ]
		]   
	);
	$self->{l_del_button}=$bfl->Button 
	( 
		-text=>"Delete", 
		-relief=>"groove",
		-command=>[ 
			sub 
			{ 
				$self->setlocal;
				$fm->setlocal;
				$fm->delete_file(@_) 
			},
			1,$self,[ \$self->{"local"} ]
			]   
	);

	$self->{r_del_button}=$bfr->Button 
	( 
		-text=>"Delete", 
		-relief=>"groove",
		-command=>[ 
			sub 
			{ 
				$self->setremote;
				$fm->setremote;
				$fm->delete_file(@_) 
			},
			0,$self,[ \$self->{remote} ]
			]   
	);

	$self->{l_md_button}=$bfl->Button 
	( 
		-text=>"Mkdir", 
		-relief=>"groove",
		-command=>[ 
			sub 
			{ 
				my $fm=shift;
				$self->setlocal; 
				$fm->setlocal;
				$self->make_dir($fm);
			},
			$fm
			]   
	);

	$self->{r_md_button}=$bfr->Button 
	( 
		-text=>"Mkdir", 
		-relief=>"groove",
		-command=>[ 
			\&make_dir,
			sub 
			{
				$self->setremote;
				$fm->setremote;
				$self->makedir;
			},
			$fm
			]   
	);
	$self->{l_rn_button}=$bfl->Button 
	( 
		-text=>"Rename", 
		-relief=>"groove",
		-command=>[ 
			sub { $self->setlocal; $fm->setlocal; $self->rename(@_); },
			1,$fm
			]   
	);

	$self->{r_rn_button}=$bfr->Button 
	( 
		-text=>"Rename", 
		-relief=>"groove",
		-command=>[ 
			sub { $self->setremote; $fm->setremote; $self->rename(@_); },
			0,$fm
			]   
	);


	$self->{l_label}=$t->Label ( -text=>"Local Operations" );
	$self->{r_label}=$t->Label ( -text=>"Remote Operations" );

	$self->{l_cwd_label}=$t->Label ( -textvariable=>\$self->{lcwd} );
	$self->{r_cwd_label}=$t->Label ( -textvariable=>\$self->{rcwd} );
	
	$self->{button_frame}->grid (-row=>0,-column=>1,-columnspan=>4,-sticky=>'nwe',-pady=>10);
		$self->{connect_button}->grid(-row=>0,-column=>2);
		$self->{bmarks_button}->grid(-row=>0,-column=>3);
		$self->{quit_button}->grid(-row=>0,-column=>4);
	#	$dir_button->grid(-row=>1,-column=>3);
	
	$self->{l_label}->grid (-row=>1,-column=>1);
	$self->{l_button_frame}->grid (-row=>2,-column=>1);
		$self->{put_button}->grid (-row=>1,-column=>1);
		$self->{l_del_button}->grid ( -row=>1,-column=>2);
		$self->{l_md_button}->grid ( -row=>1,-column=>3);
		$self->{l_rn_button}->grid ( -row=>1,-column=>4);

	
	$self->{r_label}->grid (-row=>1,-column=>3);
	$self->{r_button_frame}->grid (-row=>2,-column=>3);
		$self->{get_button}->grid (-row=>1,-column=>1);
		$self->{r_del_button}->grid ( -row=>1,-column=>2);
		$self->{r_md_button}->grid ( -row=>1,-column=>3);
		$self->{r_rn_button}->grid ( -row=>1,-column=>4);

	$self->{r_cwd_label}->grid (-row=>3, -column=>3);
	$self->{remote}->grid(-row=>4,-column=>3,-sticky=>'ew');
	$self->{remote_scroll}->grid(-row=>4,-column=>4,-sticky=>'ns');

	$self->{l_cwd_label}->grid (-row=>3, -column=>1);
	$self->{"local"}->grid(-row=>4,-column=>1,-sticky=>'ew');
	$self->{local_scroll}->grid(-row=>4,-column=>2,-sticky=>'ns');
	
	
	
	$self->{remote}->bind 
	( 
		'<Double-Button-1>', 
		[
			sub { shift; $self->setremote; $fm->setremote; $fm->cwd(@_) },  
			$self, [ \$self->{remote} ]
		] 
	);
	$self->{"local"}->bind 
	( 
		'<Double-Button-1>', 
		[
			sub { shift; $self->setlocal; $fm->setlocal; $fm->lcwd(@_) },
			$self, [ \$self->{"local"} ]
		] 
	);
	
	# state variables.
	$self->{is_local}=1;
	$self->{listbox}=$self->{local};
	$self->{connected}=0;
	$self->{DEBUG}=0;	# use 1 to print debugging messages to STDERR
	bless $self;
	
}	# new

sub DESTROY { print STDERR "calling GUI destructor\n"; shift->{top}->destroy; }

# 	Accessor methods to determine whether we will do local or remote operation

sub setlocal 
{
	my $self=shift;
	$self->{listbox}=$self->{local};
	$self->{is_local}=1;
}
sub setremote
{
	my $self=shift;
	$self->{listbox}=$self->{remote};
	$self->{is_local}=0;
}
sub set_connect
{
	my $self=shift;
	$self->{connected}=1;
	$self->{connect_button}->configure(-text=>"disconnect");
}
sub unset_connect
{
	my $self=shift;
	$self->{connected}=0;
	$self->{connect_button}->configure(-text=>"connect");
	$self->{remote}->delete(0,'end');
	$self->setrcwd("");
}

sub setlcwd
{
	my $self=shift;
	my $string=shift;
	$string  eq "/" || $string=~s:/$::;	# strip trailing slash ( if any ) 
	$self->{lcwd}=$string
}

sub setrcwd
{
	my $self=shift;
	$self->{rcwd}=shift;
}

sub isconnected { return shift->{connected}; }
sub islocal { return shift->{is_local}; }

#	Update GUI after connecting or disconnecting.

# public accessor method

sub get_top { return shift->{top}; }

sub message 
{
	my $self=shift;
	my $m=shift;
	my $d=$self->{top}->Dialog(-text=>$m)->Show();
}

sub getlist 
{
	my $self=shift;
	#my $lb=$self->{listbox};
	
	my $lb= ( $self->islocal ) ? \$self->{local} : \$self->{remote};

	$self->{DEBUG} && print STDERR $self->islocal;

	return $$lb->curselection();
}

sub confirm 
{
	my $self=shift;
	my $string=shift;
	my $resp=$self->{top}->Dialog(-text=>"$string", -buttons=>[qw/OK Cancel/ ])->Show;
	if ( $resp eq "OK" ) 
	{
	return 1;
	}
	else
	{
	return 0;
	}
}

############################################################
# 
#	Update GUI after a local or remote "ls" command.
# 
# first arg is a hash with arrayrefs of files/dirs/links.
# the second an arrayref to GUI args.
# in this case $dir_lb and $file_lb


sub dir_output 
{
	my $self=shift;
	my $f=shift; # file list
	# recall that all the GUI args were put into an array. But we only have one GUI arg : 
	# a hashref.
	my 	$lb=$self->{listbox};

#	my $frame;

	$lb->delete ( 0,'end' ) ;
		
	foreach my $item ( @{$f->{d}} ) {
		$lb->insert ('end',"$item/" );
		}
	foreach my $item ( @{$f->{l}} ) {
	  	$lb->insert ('end',"$item@" );
		}
	foreach my $item ( @{$f->{f}} ) {
		$lb->insert ('end',"$item" );
		}
} # dir_output

sub make_dir 
{
#	my $class=shift;
	my $self=shift;
	my $local=$self->{is_local};
#	my $extra_args=shift;
	my $fm=shift;
	my $md={};
	my $geometry="";
	my $config={};

	my $t=$self->{top}->Toplevel(-title=>"Connect to host");
	$geometry=$self->get_child_geometry();
	$t->geometry($geometry);
	$md->{"name"}=$t->Entry(-width=>30)->grid(-row=>1,-column=>2);
	$md->{"mode"}=$t->Entry(-width=>4)->grid(-row=>2,-column=>2);
	my $ok=$t->Button(-text=>"OK", -command=>[sub { $_[0]->destroy; }, $t ] )->grid(-row=>3,-column=>2);
	
	my $labels={};
	$labels->{name}=$t->Label(-text=>"Directory name")->grid(-row=>1,-column=>1);
	$labels->{perm}=$t->Label(-text=>"Directory permissions")->grid(-row=>2,-column=>1);

	foreach my $key ( "name","mode" ) 
	{
		$md->{$key}->OnDestroy
		( 
			[ 
				sub { my ($h,$k,$w) = @_; $h->{$k}=$w->get(); }, 
				$config,$key,$md->{$key} 
			]
		)
	}

	$t->waitWindow;

	if ( $local ) 
	{
		$fm->l_make_dir( $config->{"name" } , $config->{"mode"}, $self );
	}
	else 
	{
		$fm->r_make_dir( $config->{"name" } , $config->{"mode"}, $self );
	}

}

sub rename
{
#	my $class=shift;
	my $gui=shift;
	my $local=shift;
	my $fm=shift;
	my $md={};
	my $geometry="";
	my $config={};

	my $t=$gui->{top}->Toplevel(-title=>"Rename file");
	$geometry=$gui->get_child_geometry();
	$t->geometry($geometry);

	my $name=$t->Entry(-width=>30)->grid(-row=>1,-column=>2);
	my $ok=$t->Button(-text=>"OK", -command=>[sub { shift->destroy; }, $t ] )->grid(-row=>3,-column=>2);
	my $label=$t->Label(-text=>"New name")->grid(-row=>1,-column=>1);
	my $getlist=$gui->getlist;

	print "in sub rename : getlist = $getlist\n";

	$name->OnDestroy
	( 
		[ 
			sub { my ($h,$w) = @_; $h->{"name"}=$w->get(); }, 
			$config,$name
		]
	);

	$t->waitWindow;

	$self->{DEBUG} && print STDERR "Config->name: $config->{name} gui: $gui getlist: $getlist\n\n";

	if ( $local ) 
	{
		$fm->l_rename(  $config->{"name" } ,  $gui, $getlist );
	}
	else 
	{
		$fm->r_rename(  $config->{"name" } ,  $gui, $getlist );
	}
}

sub get_child_geometry 
{ # chooses an appropriate inital position for cihld window
	my $self=shift;
	my $p_geom=$self->{top}->geometry;
	$self->{DEBUG} && print STDERR $p_geom,"\n";
	$p_geom=~s/[^+]*\+//;
	my @geometry=split ( /[x+]/, $p_geom );
	$geometry[0]=$geometry[0]+15;
	$geometry[1]=$geometry[1]+25;
	return "+$geometry[0]+$geometry[1]"
}

sub download_prompt 
{
	my $gui=shift;
	my $ftp_ref=shift;
	my $d=shift;
	my $lcwd_ref=shift;	
	my $is_reget=shift;

	my $string="";
	my $answer="";
	my $dialog;


	if ( $is_reget == 1 ) 
	{ 
		$string="A file $$lcwd_ref$d already exists. Append or overwrite ?";
		$dialog=$gui->{top}->Dialog ( -text=>$string, -title=>"Confirm",-buttons=>[qw/Append Overwrite Cancel/]);
		
	} 
	else 
	{
		$string="A file larger (or the same size) $$lcwd_ref$d already exists. Overwrite ?";
		$dialog=$gui->{top}->Dialog ( -text=>$string, -title=>"Confirm",-buttons=>[qw/Overwrite Cancel/]);
	}
	$answer=$dialog->Show;
	return $answer;
}
################################################
#
#	Progress bar for download/upload operation.

package gui::progress_bar;

sub new 
{
	no strict "vars";
	my $class=shift;
	my $gui=shift;
	my $self={};
	my $geometry="";
	$self->{main}=$gui->{top}->Toplevel(-title=>"Progress Indicator");
	$geometry=$gui->get_child_geometry;
	$self->{main}->geometry($geometry);
	$self->{bar}=$self->{main}->ProgressBar->pack;
	$self->{label}=$self->{main}->Label->pack;
	$self->{text}="";
#	$self->{bar}->configure ( -UpdateHook=>\&Hook );
	$self->{label}->configure ( -textvariable=>\$self->{text} );
	bless $self;
}


sub update_bar 
{
	my $self=shift;
	my $pc=shift;
	my $s=shift;
	my $r=shift;
	$self->{bar}->configure( -step=> $pc );
	$self->{text}="received ". int($s/1024) ." kilobytes of " . int($r/1024). " ...". int(100*$s/$r). "%\n";

} #gui_update_bar

sub DESTROY 
{
	my $self=shift;
	$self->{DEBUG} && print STDERR "\n\nCalling DESTROY on $self->{main}\n\n";
	$self->{main}->destroy;
}

# 	End progress bar code.
# 
################################################

1;
